;---------------------------------------
;
; Search Engine utilities
; Copyright (c) 1994 by Alessandro Scotti
;
;---------------------------------------
P386
JUMPS
LOCALS

PUBLIC  seGetCountCVT
PUBLIC  seCount

;---------------------------------------
;
; Data segment
;
SE_DATA SEGMENT USE16 PARA PUBLIC 'DATA'
        ASSUME  ds:SE_DATA

CTable  DB      256     DUP(?)          ; Character count table

SE_DATA ENDS

;---------------------------------------
;
; Code segment
;
SE_TEXT SEGMENT USE16 PARA PUBLIC 'CODE'
        ASSUME  cs:SE_TEXT, es:NOTHING

;---------------------------------------
;
; Returns a pointer to the character count table.
;
; Input:
;       none
; Output:
;       DX:AX = pointer to character count table
;
seGetCVT        PROC PASCAL FAR
        mov     dx, SEG SE_DATA
        mov     ax, OFFSET CTable
        ret
seGetCVT        ENDP

seCount         PROC PASCAL FAR
        ARG     Buffer:DWORD,   \
                BufLen:WORD
        USES    ds, si, es, di

        mov     ax, SEG SE_DATA
        mov     ds, ax

        xor     ax, ax
        mov     cx, [BufLen]
        jcxz    @@Exit

        les     di, [Buffer]
        mov     si, OFFSET CTable
        xor     bx, bx

        shr     cx, 1                   ; Make CX even
        jnc     @@Loop                  ; Jump to main loop if no odd byte
        mov     bl, es:[di]
        add     al, [si+bx]
        jcxz    @@Exit                  ; Exit if end of buffer
        inc     di
@@Loop:
        mov     bl, es:[di]             ;
        inc     di
        add     al, [si+bx]
        adc     ah, 0
        mov     bl, es:[di]             ;
        inc     di
        add     al, [si+bx]
        adc     ah, 0
        dec     cx                      ; End of buffer?
        jnz     @@Loop                  ; No, continue

@@Exit:
        ret
seCount         ENDP

SE_TEXT ENDS
END
